<?php
/**
**  WEB-xSER, copyright 2008 Yannick Defais <sevmek@free.fr>
**
    This file is part of WEB-xSER.

    WEB-xSER is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    WEB-xSER is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar.  If not, see <http://www.gnu.org/licenses/>.

**
**/

/** sensible datas : connection to the DB
**/
require_once('config.inc.php');

// Include the template class.
require_once('template.class.php');
// including the navbar class
//require_once('navbar.class.php');
// including serweb functions for compatibility reasons
//require_once('functions.php');
// including functions for the database (mysql db)
require_once('msdb.php');
// including the securesession class
require_once 'securesession.class.php';
// including the random generator function
require_once 'email.class.php';	

session_start();
if (isset($_GET['page'])) {
	$_SESSION['page'] = htmlspecialchars($_GET['page']); } //security against html/xml injection (i.e. <script>)
$ss = new SecureSession();
$ss->check_browser   = true;
$ss->check_ip_blocks = 2;	//It use the first 2 blocks of the IP address to generate fingerprint, this might cause trouble.
$ss->secure_word     = 'WEB-xSER_fEhCf2G67z';	//Secret password for fingerprint generation, put what ever you want
$ss->regenerate_id   = true;

// including the validation form class
require_once 'form_validator.class.php';

// check captcha post form field, return 1 if OK
// it is case-insensitive
function check_captcha() {
  if (!isset($_POST['captcha']))
  	return 0;
  $userletters = strtoupper($_POST['captcha']);
  if (!isset($_SESSION['captcha_string']))
	return 0;
  if ($userletters === strtoupper($_SESSION['captcha_string'])) {
    // make sure that the code is only used once
  	unset($_SESSION['captcha_string']);
  	return 1; }
  return 0; }

//print check_captcha() ? "PASSED" : "FAILED";

if ( isset($_POST['uname']) ) { //User: we try to register a new SIP address.
	$test = new testTools("fielderror");
	if (isset($_POST['fname'])) {
		$formfname = $test->secure($_POST["fname"]);	//We turn the inputed datas in a safe format.
		$test->stringtest($formfname,"fname"); }	//Is this a string as expected?	
	if (isset($_POST['lname'])) {
		$formlname = $test->secure($_POST["lname"]);
		$test->stringtest($formlname,"lname"); }
	if (isset($_POST['email'])) {	
		$formemail = $test->secure($_POST["email"]);
		$test->mailtest($_POST["email"],"email"); }	//Is this a mail address as expected?
	if (isset($_POST['uname'])) {
		$formuname = $test->secure($_POST["uname"]);
		$test->stringtest($formuname,"uname"); }
	if (isset($_POST['passwd'])) {
		$formpasswd = $test->secure($_POST["passwd"]);
		$test->stringtest($formpasswd,"passwd"); }
	if (isset($_POST['passwd_r'])) {
		$formpasswd_r = $test->secure($_POST["passwd_r"]);
		$test->stringtest($formpasswd_r,"passwd_r"); }
	$field_req_firstname = $test->fieldError("fname"    ,"fieldreq");	//select the CSS design
	$field_req_lastname  = $test->fieldError("lname"    ,"fieldreq");
	$field_req_username  = $test->fieldError("uname"    ,"fieldreq");
	$field_req_email     = $test->fieldError("email"    ,"fieldreq");
	$field_req_passwd    = $test->fieldError("passwd"   ,"fieldreq");
	$field_req_passwd_r  = $test->fieldError("passwd_r" ,"fieldreq");
	$formcaptcha         = 0;
	if (!check_captcha()) {	//the captcha test failed
		$formcaptcha = 1; }
	$uname         = quote_smart($_POST['uname']);	  //against SQL injection
	$formunametook = 0;
	if ( check_db_user ($uname) ) { //username is already in our db
		$field_req_username = "fielderror";
		$formunametook      = 1; }
	$formdiffpasswd = 0;
	if ($_POST['passwd'] != $_POST['passwd_r'] || empty($_POST['passwd']) || empty($_POST['passwd_r'])  ) { //confirmation password is wrong
		$field_req_passwd   = "fielderror";
		$field_req_passwd_r = "fielderror";
		$formpasswd         = '';
		$formpasswd_r       = '';
		$formdiffpasswd     = 1; }
	$formaccept       = 1;
	$field_req_accept = "fielderror";
	if ( isset ($_POST['accept']))	{ //User accepted our terms
		$field_req_accept = "fieldreq";
		$formaccept       = 0; }
	if (!$test->Count == 0 || $formcaptcha == 1 || $formunametook == 1 || $formdiffpasswd == 1 || $formaccept == 1) { //There is at least 1 error.
		$tpl_file_outer = 'index.tpl.php';
		$tpl_file_inner = 'register.tpl.php';
		$tpl  = & new Template($tpl_path);	//We do not cache this
		$tpl->set('title', 'Ekiga.net: Error preventing the registration process to continue. Please, read above.');
		$body = & new Template($tpl_path);
		$body->set('field_req_firstname', $field_req_firstname);
		$body->set('field_req_lastname' , $field_req_lastname);
		$body->set('field_req_username' , $field_req_username);
		$body->set('field_req_email'    , $field_req_email);
		$body->set('field_req_passwd'   , $field_req_passwd);
		$body->set('field_req_passwd_r' , $field_req_passwd_r);
		$body->set('field_req_accept'   , $field_req_accept);
		$body->set('formfname'          , $formfname);
		$body->set('formlname'          , $formlname);
		$body->set('formuname'          , $formuname);
		$body->set('formpasswd'		, $formpasswd);
		$body->set('formpasswd_r'	, $formpasswd_r);
		$body->set('formemail'          , $formemail);
		$body->set('formaccept'         , $formaccept);
		$body->set('formcaptcha'        , $formcaptcha);
		$body->set('formunametook'      , $formunametook);
		$body->set('formdiffpasswd'     , $formdiffpasswd);
		$body->set('formaccept'         , $formaccept);
		$tpl->set('body', $body->fetch($tpl_file_inner));  
		echo $tpl->fetch($tpl_file_outer);
               	die(); }
        else { // We can add this new user to our DB :-) Welcome!
		$fname    = quote_smart($_POST["fname"]);	  //against SQL injection
		$lname    = quote_smart($_POST["lname"]);	  //against SQL injection
		$email    = quote_smart($_POST["email"]);	  //against SQL injection
		$passwd   = quote_smart($_POST["passwd"]);	  //against SQL injection
		//$passwd_r = quote_smart($_POST["passwd_r"]);	  //against SQL injection
		if (!add_user ($uname, $passwd, $email, $fname, $lname))
			{ //something get wrong when trying to add the new user, we restart.
			$tpl_file_outer = 'index.tpl.php';
			$tpl_file_inner = 'register.tpl.php';
			$tpl = & new Template($tpl_path);	//We do not cache this
			$tpl->set('title', 'Ekiga.net: ERROR, Could not add the datas to the DB.');
			$body = & new Template($tpl_path);
			$body->set('field_req_firstname', $field_req_firstname);
			$body->set('field_req_lastname' , $field_req_lastname);
			$body->set('field_req_username' , $field_req_username);
			$body->set('field_req_email'    , $field_req_email);
			$body->set('field_req_passwd'   , $field_req_passwd);
			$body->set('field_req_passwd_r' , $field_req_passwd_r);
			$body->set('field_req_accept'   , $field_req_accept);
			$body->set('formaccept'         , $formaccept);
			$body->set('formfname'          , $formfname);
			$body->set('formlname'          , $formlname);
			$body->set('formuname'          , $formuname);
			$body->set('formpasswd'		, $formpasswd);
			$body->set('formpasswd_r'	, $formpasswd_r);
			$body->set('formemail'          , $formemail);
			$body->set('formaccept'         , $formaccept);
			$tpl->set('body', $body->fetch($tpl_file_inner));  
			echo $tpl->fetch($tpl_file_outer);
	  		die; }
		//Send an email with all relevant datas:
		$name     = $formfname. " " . $formlname;
		$mail_tpl = & new Template($tpl_path);	//We do not cache this
		$mail_tpl->set('name',     $name);
		$mail_tpl->set('uname',    $formuname);
		$mail_tpl->set('password', $formpasswd);
		$comment = $mail_tpl->fetch('email_registration_confirmation.tpl.php');
		$mail    = & new mailTools($formemail, $name, 'noreply@ekiga.net', 'Welcome to Ekiga.net!', $comment);
		if (!$mail->send_Mail()) { //error while trying to send the email!
			/*$tpl_file_outer = 'index.tpl.php';
			$tpl_file_inner = 'forgot.tpl.php';
			$tpl = & new Template($tpl_path);	//We do not cache this
			$tpl->set('title', 'Ekiga.net: Error while sending the email. Please, retry...');
			$body = & new Template($tpl_path);
			$body->set('field_req_fp_username' , $field_req_fp_username);
			$body->set('formfp_uname',           $formfp_uname);
			$body->set('formfp_unametook',       $formfp_unametook);
			$tpl->set('body', $body->fetch($tpl_file_inner));  
			echo $tpl->fetch($tpl_file_outer);
	               	die();*/
			Echo "Error while sending the email..."; }
		//New datas properly added to our DB.
		$tpl_file_outer = 'index.tpl.php';
		$tpl_file_inner = 'registration_confirmation.tpl.php';
		$tpl = & new Template($tpl_path);	//We do not cache this
		$tpl->set('title', 'Ekiga.net: Thank you for using our VoIP service :-)');
		$body = & new Template($tpl_path);
		//$body->set('formemail', $formemail);
		$body->set('formuname',  $formuname);
		$body->set('formpasswd', $formpasswd);
		$body->set('formemail',  $formemail);
		$tpl->set('body', $body->fetch($tpl_file_inner));  
		echo $tpl->fetch($tpl_file_outer);
		die(); }
	}

if (isset($_GET['page']) && $_GET['page'] == "register") { //Register a SIP Address page
	//$test = new testTools("fielderror"); 	//to validate the form
	$tpl_file_outer = 'index.tpl.php';	//template system
	$tpl_file_inner = 'register.tpl.php';
	$cache_id       = $tpl_file_outer . $tpl_file_inner; //  . $_SERVER['REQUEST_URI']; We should add langage at some point
	$tpl            = & new CachedTemplate($tpl_path, $cache_id, $debug_cacheTime);
	if(!($tpl->is_cached())) {
		$tpl->set('title', 'Ekiga.net: Register a SIP-Address.');
		$body = & new Template($tpl_path);
		//$timezone = array_map('rtrim',file('./templates/timezone.tpl.php'));  //we might optimize by caching the timezone only
		//$body->set('time_zone', $timezone);
		$tpl->set('body', $body->fetch($tpl_file_inner)); }
	echo $tpl->fetch_cache($tpl_file_outer);
	die(); }
	
if ( isset($_POST['fp_uname']) ) { //User: we try to send an email with the password
	$test = new testTools("fielderror");
	$formfp_uname = $test->secure($_POST["fp_uname"]);
	$test->stringtest($formfp_uname,"fp_uname");
	$field_req_fp_username  = $test->fieldError("fp_uname"    ,"fieldreq");	//select the CSS design
	$fp_uname    = quote_smart($_POST['fp_uname']);	  //against SQL injection
	$formfp_unametook = 0;
	if ( !check_db_user ($fp_uname) ) { //Error: username is NOT already in our db
		$field_req_fp_username = "fielderror";
		$formfp_unametook      = 1; }
	if (!$test->Count == 0 || $formfp_unametook == 1) { //There is at least 1 error.
		$tpl_file_outer = 'index.tpl.php';
		$tpl_file_inner = 'forgot.tpl.php';
		$tpl = & new Template($tpl_path);	//We do not cache this
		$tpl->set('title', 'Ekiga.net: Error preventing the reminder mail to be sent. Please, read above.');
		$body = & new Template($tpl_path);
		$body->set('field_req_fp_username' , $field_req_fp_username);
		$body->set('formfp_uname',           $formfp_uname);
		$body->set('formfp_unametook',       $formfp_unametook);
		$tpl->set('body', $body->fetch($tpl_file_inner));  
		echo $tpl->fetch($tpl_file_outer);
               	die(); }
	else { //User is in our DB, let's retrieve necessary datas and send an email
		list ($first_name, $last_name, $to, $password) = retrieve_datas_db($fp_uname);
		$name = $first_name . " " . $last_name;
		$mail_tpl = & new Template($tpl_path);	//We do not cache this
		$mail_tpl->set('name',     $name);
		$mail_tpl->set('uname',    $formfp_uname);
		$mail_tpl->set('password', $password);
		$comment = $mail_tpl->fetch('email_password_reminder.tpl.php');
		$mail = & new mailTools($to, $name, 'noreply@ekiga.net', 'Ekiga.net password reminder', $comment);
		if ($mail->send_Mail()) { //mail sent successfully
			$tpl_file_outer = 'index.tpl.php';
			$tpl_file_inner = 'password_sent_confirmation.tpl.php';
			$tpl = & new Template($tpl_path);	//We do not cache this
			$tpl->set('title', 'Ekiga.net: Mail sent.');
			$body = & new Template($tpl_path);
			$body->set('formemail' , $to);
			$tpl->set('body', $body->fetch($tpl_file_inner));  
			echo $tpl->fetch($tpl_file_outer);
	               	die(); }
		else { //error while trying to send the email!
			$tpl_file_outer = 'index.tpl.php';
			$tpl_file_inner = 'forgot.tpl.php';
			$tpl = & new Template($tpl_path);	//We do not cache this
			$tpl->set('title', 'Ekiga.net: Error while sending the email. Please, retry...');
			$body = & new Template($tpl_path);
			$body->set('field_req_fp_username' , $field_req_fp_username);
			$body->set('formfp_uname',           $formfp_uname);
			$body->set('formfp_unametook',       $formfp_unametook);
			$tpl->set('body', $body->fetch($tpl_file_inner));  
			echo $tpl->fetch($tpl_file_outer);
	               	die(); }
		}
	}

if (isset($_GET['page']) && $_GET['page'] == "forgot") { //Password forgotten?
	$tpl_file_outer = 'index.tpl.php';
	$tpl_file_inner = 'forgot.tpl.php';
	$cache_id       = $tpl_file_outer . $tpl_file_inner; //  . $_SERVER['REQUEST_URI']; We should add langage at some point
	$tpl            = & new CachedTemplate($tpl_path, $cache_id, $debug_cacheTime);
	if(!($tpl->is_cached())) {
		$tpl->set('title', 'Ekiga.net: Forgot your password?');
		$body = & new Template($tpl_path);
		$tpl->set('body', $body->fetch($tpl_file_inner)); }
	echo $tpl->fetch_cache($tpl_file_outer);
	die(); }

if ( isset($_POST['chpass_uname']) ) { //User: we try to change your password
	$test = new testTools("fielderror");
	if (isset($_POST['chpass_uname'])) {
		$formchpass_uname = $test->secure($_POST["chpass_uname"]);	//We turn the inputed datas in a safe format.
		$test->stringtest($formchpass_uname,"chpass_uname"); }	//Is this a string as expected?	
	$field_req_chpass_uname  = $test->fieldError("chpass_uname"    ,"fieldreq");	//select the CSS design
	if (isset($_POST['oldpasswd'])) {
		$formoldpasswd = $test->secure($_POST["oldpasswd"]);
		$test->stringtest($formoldpasswd,"oldpasswd"); }
	$field_req_oldpasswd = $test->fieldError("oldpasswd"    ,"fieldreq");	//select the CSS design
	if (isset($_POST['newpasswd'])) {
		$formnewpasswd = $test->secure($_POST["newpasswd"]);
		$test->stringtest($formnewpasswd,"newpasswd"); }
	$field_req_newpasswd = $test->fieldError("newpasswd"    ,"fieldreq");	//select the CSS design
	if (isset($_POST['newpasswd_r'])) {
		$formnewpasswd_r = $test->secure($_POST["newpasswd_r"]);
		$test->stringtest($formnewpasswd_r,"newpasswd_r"); }
	$field_req_newpasswd_r = $test->fieldError("newpasswd_r"    ,"fieldreq");	//select the CSS design
	$chpass_uname    = quote_smart($_POST['chpass_uname']);	   //against SQL injection
	$oldpasswd       = quote_smart($_POST['oldpasswd']);	   //against SQL injection
	$formcaptcha         = 0;
	if (!check_captcha()) {	//the captcha test failed
		$formcaptcha = 1; }
	$formchpassunametook = 0;
	$formoldpasswdtook = 0;
	if ( !check_db_user ($chpass_uname) ) { //username is NOT already in our db
		$field_req_chpass_uname = "fielderror";
		$formchpassunametook= 1; }
	else {	//username is already in our db: GOOD!
		if ( !check_password($chpass_uname,$oldpasswd) || empty($_POST['oldpasswd']) ) {	//is the oldpassword the right one?
			$field_req_oldpasswd = "fielderror";						//no, it isn't!
			$formoldpasswd       = '';
			$formoldpasswdtook   = 1; } }
	$formdiffpasswdtook = 0;
	if ($_POST['newpasswd'] != $_POST['newpasswd_r'] || empty($_POST['newpasswd']) || empty($_POST['newpasswd_r'])  ) { //is confirmation password  wrong?
		$field_req_newpasswd   = "fielderror";
		$field_req_newpasswd_r = "fielderror";
		$formnewpasswd         = '';
		$formnewpasswd_r       = '';
		$formdiffpasswdtook    = 1; }
	if (!$test->Count == 0 || $formchpassunametook == 1 || $formoldpasswdtook == 1 || $formdiffpasswdtook == 1 || $formcaptcha == 1 ) { //There is at least 1 error.
		$tpl_file_outer = 'index.tpl.php';
		$tpl_file_inner = 'chpasswd.tpl.php';
		$tpl = & new Template($tpl_path);	//We do not cache this
		$tpl->set('title', 'Ekiga.net: Error preventing the password to be updated. Please, read above.');
		$body = & new Template($tpl_path);
		$body->set('field_req_chpass_uname', $field_req_chpass_uname);
		$body->set('field_req_oldpasswd',    $field_req_oldpasswd);
		$body->set('field_req_newpasswd',    $field_req_newpasswd);
		$body->set('field_req_newpasswd_r',  $field_req_newpasswd_r);
		$body->set('formcaptcha',            $formcaptcha);
		$body->set('formchpass_uname',       $formchpass_uname);
		$body->set('formoldpasswd',          $formoldpasswd);
		$body->set('formnewpasswd',          $formnewpasswd);
		$body->set('formnewpasswd_r',        $formnewpasswd_r);
		$body->set('formchpassunametook',    $formchpassunametook);
		$body->set('formoldpasswdtook',      $formoldpasswdtook);
		$body->set('formdiffpasswdtook',     $formdiffpasswdtook);
		$tpl->set('body', $body->fetch($tpl_file_inner));  
		echo $tpl->fetch($tpl_file_outer);
               	die();
               	}
	else { //The form is fine, let's update the password and send a mail
		$newpasswd       = quote_smart($_POST['newpasswd']);	   //against SQL injection
		if ( !change_password($chpass_uname,$newpasswd) ) { //something get wrong when trying to update the password, we restart.
			$tpl_file_outer = 'index.tpl.php';
			$tpl_file_inner = 'chpasswd.tpl.php';
			$tpl = & new Template($tpl_path);	//We do not cache this
			$tpl->set('title', 'Ekiga.net: Error while trying to update the password. Please, restart.');
			$body = & new Template($tpl_path);
			$body->set('field_req_chpass_uname', $field_req_chpass_uname);
			$body->set('field_req_oldpasswd',    $field_req_oldpasswd);
			$body->set('field_req_newpasswd',    $field_req_newpasswd);
			$body->set('field_req_newpasswd_r',  $field_req_newpasswd_r);
			$body->set('formchpass_uname',       $formchpass_uname);
			$body->set('formoldpasswd',          $formoldpasswd);
			$body->set('formnewpasswd',          $formnewpasswd);
			$body->set('formnewpasswd_r',        $formnewpasswd_r);
			$body->set('formchpassunametook',    $formchpassunametook);
			$body->set('formoldpasswdtook',      $formoldpasswdtook);
			$body->set('formdiffpasswdtook',     $formdiffpasswdtook);
			$tpl->set('body', $body->fetch($tpl_file_inner));  
			echo $tpl->fetch($tpl_file_outer);
	               	die();
			}
		list ($first_name, $last_name, $to, $password) = retrieve_datas_db($chpass_uname);
		$name = $first_name . " " . $last_name;
		$mail_tpl = & new Template($tpl_path);	//We do not cache this
		$mail_tpl->set('name',     $name);
		$mail_tpl->set('uname',    $formchpass_uname);
		$mail_tpl->set('password', $password);
		$comment = $mail_tpl->fetch('email_password_updated.tpl.php');
		$mail = & new mailTools($to, $name, 'noreply@ekiga.net', 'Ekiga.net password update', $comment);
		if ($mail->send_Mail())
			{ //mail sent successfully
			$tpl_file_outer = 'index.tpl.php';
			$tpl_file_inner = 'password_updated_confirmation.tpl.php';
			$tpl = & new Template($tpl_path);	//We do not cache this
			$tpl->set('title', 'Ekiga.net: Mail sent.');
			$body = & new Template($tpl_path);
			$body->set('formemail' , $to);
			$tpl->set('body', $body->fetch($tpl_file_inner));  
			echo $tpl->fetch($tpl_file_outer);
	               	die();
			}
		else
			{ //error while trying to send the email!
			$tpl_file_outer = 'index.tpl.php';
			$tpl_file_inner = "Error: We could no sent an email for confirmation. Still the password has been updated, your nex password is: $formnewpasswd";
			$tpl = & new Template($tpl_path);	//We do not cache this
			$tpl->set('title', 'Ekiga.net: Error while sending the email.');
			$body = & new Template($tpl_path);
			$tpl->set('body', $tpl_file_inner);  
			echo $tpl->fetch($tpl_file_outer);
	               	die();
			}
		}
	}

if (isset($_GET['page']) && $_GET['page'] == "chpass") { //Password forgotten?
	$tpl_file_outer = 'index.tpl.php';
	$tpl_file_inner = 'chpasswd.tpl.php';
	$cache_id       = $tpl_file_outer . $tpl_file_inner; //  . $_SERVER['REQUEST_URI']; We should add langage at some point
	$tpl = & new CachedTemplate($tpl_path, $cache_id, $debug_cacheTime);
	if(!($tpl->is_cached())) {
		$tpl->set('title', 'Ekiga.net: Change your password');
		$body = & new Template($tpl_path);
		$tpl->set('body', $body->fetch($tpl_file_inner)); }
	echo $tpl->fetch_cache($tpl_file_outer);
	die(); }

if (isset($_GET['page']) && $_GET['page'] == "services") { //Ekiga.net services description
	$tpl_file_outer = 'index.tpl.php';
	$tpl_file_inner = 'services.tpl.php';
	$cache_id       = $tpl_file_outer . $tpl_file_inner; //  . $_SERVER['REQUEST_URI']; We should add langage at some point
	$tpl = & new CachedTemplate($tpl_path, $cache_id, $debug_cacheTime);
	if(!($tpl->is_cached())) {
		$tpl->set('title', 'Ekiga.net: What are the service provided by Ekiga.net?');
		$body = & new Template($tpl_path);
		$tpl->set('body', $body->fetch($tpl_file_inner)); }
	echo $tpl->fetch_cache($tpl_file_outer);
	die(); }
		
// display the home page (login page)
$tpl_file_outer = 'index.tpl.php';
$tpl_file_inner = 'login.tpl.php';
$cache_id       = $tpl_file_outer . $tpl_file_inner; //  . $_SERVER['REQUEST_URI']; We should add langage at some point
$tpl = & new CachedTemplate($tpl_path, $cache_id, $debug_cacheTime);
if(!($tpl->is_cached())) {
	list ($num_registered_users, $num_online_users) = how_many_users_in_db();
	$tpl->set('title', 'Ekiga.net: Welcome.');
	$body = & new Template($tpl_path);
	$body->set('numregisteredusers', $num_registered_users);
	$body->set('numonlineusers', ($num_online_users));
	$tpl->set('body', $body->fetch($tpl_file_inner)); }
echo $tpl->fetch_cache($tpl_file_outer);	
//die();	

?>
