<?
/**
**  WEB-xSER, copyright 2008 Yannick Defais <sevmek@free.fr>
**
    This file is part of WEB-xSER.

    WEB-xSER is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    WEB-xSER is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar.  If not, see <http://www.gnu.org/licenses/>.

**
**/
if( !function_exists( 'pg_query_params' ) ) {
        function pg_query_params__callback( $at ) {
                global $pg_query_params__parameters;
                return $pg_query_params__parameters[ $at[1]-1 ];
        }
		
	function pg_query_params( $db, $query, $parameters ) {	// SECURITY against SQL injection
		// Escape parameters as required & build parameters for callback function
		global $pg_query_params__parameters;
    		foreach( $parameters as $k=>$v ) {
        		if ( is_null($v) ) {
            			$parameters[$k] = 'NULL';
        		} else {
            			$parameters[$k] = ( is_int( $v ) ? $v : "'".pg_escape_string( $v )."'" );
        		}
    		}
    		$pg_query_params__parameters = $parameters;
    		// Call using pg_query
		//echo "<br />*-*" . preg_replace_callback( '/\$([0-9]+)/', 'pg_query_params__callback', $query) . "*-*";
    		return pg_query( $db, preg_replace_callback( '/\$([0-9]+)/', 'pg_query_params__callback', $query));
  	}
}
// Example: pg_query_params( $db_resource, "SELECT * FROM table WHERE col1=$1 AND col2=$2", array( 42, "It's ok" ) );
	
	
class Timer_SQL
{
	var $time_diff      = 0;        // holds the difference in time
	var $time_start     = 0;        // start time for the timer
	/**
	 * Returns last measured duration (time between TimerStart and TimerStop)
	 *
	 * @param integer $decimals (Optional) The number of decimal places to show
	 * @return Float Microseconds elapsed
	 */
	function TimerDuration($decimals = 4) {
		global $time_diff;
		return number_format($this->time_diff, $decimals);
	}

	/**
	 * Starts time measurement (in microseconds)
	 *
	 */
	function TimerStart() {
		global $time_diff;
		global $time_start;
		$parts = explode(" ", microtime());
		$this->time_diff = 0;
		$this->time_start = $parts[1].substr($parts[0],1);
	}

	/**
	 * Stops time measurement (in microseconds)
	 *
	 */
	function TimerStop() {
		global $time_diff;
		global $time_start;	
		$parts  = explode(" ", microtime());
		$time_stop = $parts[1].substr($parts[0],1);
		$this->time_diff  = ($time_stop - $this->time_start);
		$this->time_start = 0;
	}
}

function check_db_password($id, $password)
	{
	global $connect_pgdb;
	
	$id = pg_escape_string($id);	//security against SQL injection
	$connection = pg_connect($connect_pgdb)
	or die ("Unable to connect PostGreSQL --> " . pg_last_error($conn));
	if ($results = pg_select($connection, 'subscriber',array("username" => $id) ))
		{
		if ( $results[0]["password"] == $password )
			{
			pg_close($connection); // Close this connection
			return true;
			}
		else
			{
			pg_close($connection);
			return false;
			}
		}
	else
		{
		pg_close($connection); // Close this connection
		return false;
		}
	}
	
function how_many_users_in_db()
	{
	global $connect_pgdb;
	
	$connection = pg_connect($connect_pgdb)
	or die ("Unable to connect PostGreSQL --> " . pg_last_error($conn));
	$result = pg_query($connection, "SELECT count(*) FROM subscriber");
	$num_registered_users = pg_fetch_row($result);
	$result = pg_query($connection, "SELECT count(*) FROM location");
	$num_online_users = pg_fetch_row($result);
	pg_close($connection); // Close this connection
	--$num_online_users[0]; // It seems there is always at least 1 user online... Is it OPENSER itself?
	return array ($num_registered_users[0], $num_online_users[0]);
	}
	
function detail_infos_user($username)
	{
	global $connect_pgdb;
	
	$connection = pg_connect($connect_pgdb)
	or die ("Unable to connect PostGreSQL --> " . pg_last_error($conn));

	$result= pg_query_params($connection, "SELECT first_name, last_name, email_address, timezone, phone, allow_find, (array_to_string(array(select username from aliases where contact='sip:' || s.username || '@' || s.domain), ',')) as aliases FROM subscriber s WHERE username=$1", array($username)); //Security against SQL injection
	$row_tmp = pg_fetch_row($result);
	pg_close($connection); // Close this connection
	return array ($row_tmp[0], $row_tmp[1], $row_tmp[2], $row_tmp[3], $row_tmp[4], $row_tmp[5], $row_tmp[6]);
	}
	
function show_phonebook($user)
	{
	global $connect_pgdb;
	
	$connection = pg_connect($connect_pgdb)
	or die ("Unable to connect PostGreSQL --> " . pg_last_error($conn));
	$result= pg_query_params($connection, "select fname || ' ' || lname as name, sip_uri, (sip_uri in (select 'sip:' || username || '@' || domain from location))::integer as online_status, array_to_string(array(select a.username from aliases a where a.contact=p.sip_uri), ',') as aliases from phonebook p where username=$1", array($user)); //Security against SQL injection
	while ($row_tmp = pg_fetch_row($result)) 
		{
		$name_[] = $row_tmp[0];
		$sip_uri[] = $row_tmp[1];
		$online_[] = $row_tmp[2];
		$alias_[] = $row_tmp[3];
		}
	pg_close($connection); // Close this connection
	return array ($name_, $sip_uri, $online_, $alias_);
	}

function search_db()
	{
	global $connect_pgdb;
	global $time_diff;        // holds the difference in time
	global $time_start;        // start time for the timer

	$counter = 1;
	$query_count = "SELECT count(*) FROM (SELECT distinct s.username, s.domain FROM subscriber s";
	$query = "SELECT s.first_name || ' ' || s.last_name as name, 'sip:' || s.username || '@' || s.domain as sip_uri,  s.timezone FROM subscriber s";
	$query_part2 = " WHERE s.allow_find='1'";
	if ( $_GET['wp_fname'])
		{
		$query_part2 .= " AND lower(s.first_name) LIKE lower($" . $counter . ")";
		++$counter;
		$a = pg_escape_string($_GET['wp_fname']);	//security against SQL injection
		$tmp[] = "%" . $a . "%";
		}
	if( $_GET['wp_lname'])
		{
		$query_part2 .= " AND lower(s.last_name) LIKE lower($" . $counter . ")";
		++$counter;
		$a = pg_escape_string($_GET['wp_lname']);	//security against SQL injection
		$tmp[] = "%" . $a . "%";
		}
	if( $_GET['wp_uname'])
		{
		$query_part2 .= " AND lower(s.username) LIKE lower($" . $counter . ")"; //" username=$" . $counter;
		++$counter;
		$a = pg_escape_string($_GET['wp_uname']);	//security against SQL injection
		$tmp[] = "%" . $a . "%";
		}
	if( $_GET['wp_sip_uri'])
		{			
		$query_part2 .= " AND s.username = $".$counter." AND s.domain = $".($counter+1)."";
		++$counter;
		++$counter;
		$reg=new Creg;
		$a = pg_escape_string($reg->get_username($_GET['wp_sip_uri']));	//security against SQL injection
		$b = pg_escape_string($reg->get_domainname($_GET['wp_sip_uri'])); //security against SQL injection
		$tmp[] = $a;
		$tmp[] = $b;
		}
	if( $_GET['wp_alias'])
		{
		$query_count .= " , aliases a";
		$query .= " , aliases a";
		$query_part2 .= " AND a.username LIKE $".$counter." AND (lower(a.contact) = lower('sip:' || s.username || '@' || s.domain))";
		++$counter;
		$a = pg_escape_string($_GET['wp_alias']); //security against SQL injection
		$tmp[] = "%" . $a . "%";
		}
	if( $_GET['wp_onlineonly'] == "1")
		{
		$query_count .= " , location l";
		$query .= " , location l";
		$query_part2 .= " AND l.username = s.username";
		}
	if ($counter!=1)
		{	//the form is not empty
		$query .= $query_part2;
		$query_count .= $query_part2 . ") as v1";
		// initiate the navbar
		$nav = new navbar;
		// set how many records to show at a time
		$nav->numrowsperpage = 20;
		$connection = pg_connect($connect_pgdb)
		or die ("Unable to connect PostGreSQL --> " . pg_last_error($conn));
		$query_alias = "SELECT username FROM aliases a WHERE a.contact=$1";
		$tmp_timer = new Timer_SQL;
		$tmp_timer -> TimerStart();
		$result = $nav->execute($query, $query_count, $connection, "pgsql", $tmp);
		while ($row_tmp = pg_fetch_row($result)) 
			{
			$name_[] = $row_tmp[0];
			$sip_uri[] = $row_tmp[1];
			$timezone_[] = $row_tmp[2];
			$tmp_alias[0] = $row_tmp[1];
			$result_alias = pg_query_params($connection, $query_alias, $tmp_alias);
			$row_tmp_alias = pg_fetch_row($result_alias);
			$alias_[] = $row_tmp_alias[0];
			}
		$tmp_timer -> TimerStop();
		$timer_ = $tmp_timer->TimerDuration(1);
		pg_close($connection); // Close this connection
		// build the returned array of navigation links
		$links_ = $nav->getlinks("pages", "off");
		}
	return array ($name_, $sip_uri, $timezone_, $alias_, $timer_, $links_);
	}
?>
